unit UIKit;

{$mode objfpc}{$H+}
{$linkframework UIKit}

// possible linker switch required:
// -syslibroot /Developer/Platforms/iPhoneSimulator.platform/Developer/SDKs/iPhoneSimulator2.0.sdk
// -F/Developer/Platforms/iPhoneSimulator.platform/Developer/SDKs/iPhoneSimulator2.0.sdk/System/Library/Frameworks
// or
// -F/Developer/Platforms/iPhoneSimulator.platform/Developer/SDKs/iPhoneSimulator2.1.sdk/System/Library/Frameworks
// -F/Developer/Platforms/iPhoneSimulator.platform/Developer/SDKs/iPhoneSimulator2.2.sdk/System/Library/Frameworks

interface

uses
  objcrtl, Foundation, iPhoneOSAll;

type
  UIWindow = id;
  UIApplication = id;
  UIScreen = id;
  UIView = id;
  UIColor = id;

function UIGraphicsGetCurrentContext: CGContextRef; cdecl; external;
procedure UIRectFill(r: CGRect); cdecl; external;
function UIApplicationMain(argc: Integer; argv:PPChar; principalClassName, delegateClassName: NSString): Integer; cdecl; external;
//UIKIT_EXTERN int UIApplicationMain(int argc, char *argv[], NSString *principalClassName, NSString *delegateClassName);

// UTILITY functions, replacment for PasCocoa wrappers


procedure UIView_set_backgroundColor(view: UIView; color: UIColor);
function UIView_initWithFrame(view: UIView; const r: CGRect): UIView;
function UIView_get_opaque(view: UIView): Boolean;
procedure UIView_set_opaque(view: UIView; aopaque: Boolean);

function UIScreen_mainScreen: UIScreen;
function UIScreen_get_bounds(screen: UIScreen): CGRect;

function UIWindow_initWithFrame(const r: CGRect): UIWindow;

procedure UIWindow_makeKeyAndVisible(uiwin: UIWindow);

function UIColor_colorWithRed_green_blue_alpha(red, green, blue, alpha: CGFloat): UIColor;

function UIApplicaiton_sharedApplicaiton: UIApplication;

implementation

uses
  objcrtlutils; // required only by utility functions

procedure UIView_set_backgroundColor(view: UIView; color: UIColor);
begin
  objc_msgSend(view, selector('setBackgroundColor:'), [color]);
end;

function UIView_initWithFrame(view: UIView; const r: CGRect): UIView;
type
  TMsgProc = function (trg: id; _cmd: SEL; r: CGRect): id; cdecl;
begin
  Result := TMsgProc(objc_msgSend)(view, selector('initWithFrame:'), r);
end;

function UIView_get_Opaque(view: UIView): Boolean;
begin
  {$WARNINGS OFF} // Convertion between ordinals and pointers is not protable
  Result := Boolean(objc_msgSend(view, selector('isOpaque'), [])); // isOpaque is getter method, see @property opaque UIView docs
  {$WARNINGS ON}
end;

procedure UIView_set_Opaque(view: UIView; aopaque: Boolean);
begin
  objc_msgSend(view, selector('setOpaque:'), [aopaque]);
end;

function UIScreen_mainScreen: UIScreen;
begin
  Result := objc_msgSend( objcclass('UIScreen'), selector('mainScreen'), []);
end;

function UIScreen_get_bounds(screen: UIScreen): CGRect;
begin
  objc_msgSend_stret(@Result, screen, selector('bounds'), []);
end;

function UIWindow_initWithFrame(const r: CGRect): UIWindow;
begin
  Result := UIWindow(UIView_initWithFrame(alloc('UIWindow'), r));
end;

procedure UIWindow_makeKeyAndVisible(uiwin: UIWindow);
begin
  objc_msgSend(uiwin, selector('makeKeyAndVisible'), []);
end;

function UIColor_colorWithRed_green_blue_alpha(red, green, blue, alpha: CGFLoat): UIColor;
begin
  Result := objc_msgSend(objcclass('UIColor'), selector('colorWithRed:green:blue:alpha:'), [red,green, blue, alpha])
end;

function UIApplicaiton_sharedApplicaiton: UIApplication;
begin
  Result := objc_msgSend(objcclass('UIApplication'), selector('sharedAppliation'), []);
end;

end.

