program iPhoneMore;

{$mode objfpc}

uses
  objcrtl, objcrtliPhoneOS, objcrtlutils, // Objective-C support
  UIKit, Foundation, iPhoneOSAll; // iPhone API

type
  MyAppDelegate = id;
  MyMainWindow  = id;

var
  mainWin     : MyMainWindow = nil;
  appDelegate : MyAppDelegate = nil;
const
  text        = '// Pure FreePascal iPhone app';
  text2       = '// Thank you, Jonas';
  line1       = 'begin';
  line2       = '  writeln(''hello world'');';
  line3       = 'end.';

procedure MyMainWindow_drawRect(self: id; _cmd: SEL; c: CGRect); cdecl;
var
  ctx : CGContextRef;
begin
  ctx := UIGraphicsGetCurrentContext;
  CGContextSetRGBFillColor(ctx, 0, 0.0, 0.25, 1);
  UIRectFill(c);


  CGContextScaleCTM(ctx, 1, -1);
  CGContextTranslateCTM(ctx, 0, -c.size.height);

  CGContextSetRGBFillColor(ctx, 1, 1, 0, 1);
  CGContextSetRGBStrokeColor(ctx, 1, 1, 0, 1);

  CGContextSelectFont(ctx, 'Helvetica', 20, kCGEncodingMacRoman);
  CGContextShowTextAtPoint(ctx, 10, c.size.height - 50, text, length(text));
  CGContextShowTextAtPoint(ctx, 10, c.size.height - 100, text2, length(text2));
  CGContextShowTextAtPoint(ctx, 10, c.size.height - 130, line1, length(line1));
  CGContextShowTextAtPoint(ctx, 10, c.size.height - 160, line2, length(line2));
  CGContextShowTextAtPoint(ctx, 10, c.size.height - 190, line3, length(line3));

  CGContextTranslateCTM(ctx, 0, c.size.height);
  CGContextScaleCTM(ctx, 1, -1);
end;

procedure MyAppDelegate_applicationDidFinishLaunching(self: id; _cmd: SEL; app: UIApplication); cdecl;
var
  screen  : UIScreen;
  r       : CGRect;
begin
  screen := UIScreen_mainScreen;
  if Assigned(screen) then begin
    // Override point for customization after application launch
    r := UIScreen_get_bounds(screen);
    if not Assigned(mainWin) then begin
      //mainWin := UIWindow_initWithFrame(GetCGRect(0,0,200,200));
      mainWin := alloc('MyMainWindow');
      mainWin := UIView_initWithFrame(mainWin, r);
    end;

    UIView_set_backgroundColor(mainWin, UIColor_colorWithRed_green_blue_alpha(1, 0, 0, 1) );
    UIView_set_opaque(mainWin, true);
    UIWindow_makeKeyAndVisible(mainWin);
  end;
end;

function RegisterAppDelegateClass(const ClassName: AnsiString): _class;
begin
  Result := objc_allocateClassPair( objcclass('NSObject'), PChar(ClassName), 0);
  if not Assigned(Result) then Exit;

  class_addMethod(Result, selector('applicationDidFinishLaunching:'), @MyAppDelegate_applicationDidFinishLaunching, '@@:');
  objc_registerClassPair(Result);
end;

function RegisterMainWindow(const ClassName: AnsiString): _class;
begin
  Result := objc_allocateClassPair( objcclass('UIWindow'), PChar(ClassName), 0);
  if not Assigned(Result) then Exit;

  class_addMethod(Result, selector('drawRect:'), @MyMainWindow_drawRect, 'v@:{CGRect=ffff}');

  objc_registerClassPair(Result);
end;

var
  pool    : NSAutoreleasePool;
  retVal  : Integer;
begin
  RegisterMainWindow('MyMainWindow');

  RegisterAppDelegateClass('MyAppDelegate');
  appDelegate := alloc('MyAppDelegate');
  if not Assigned(appDelegate) then Exit;

  writeln('Hello world');
  pool := AllocAndInit('NSAutoreleasePool');

  retVal := UIApplicationMain(argc, argv, nil, NSStr('MyAppDelegate'));

  release(pool);
  ExitCode := retVal;
end.

