unit iPhoneOSAll;

{$mode objfpc}{$H+}

interface

{$linkframework CoreGraphics}

//uses MacOSAll; //todo: move here from MacOSAll as much as .. iPhoneOS supported :)

type
	CFStringRef = ^SInt32; { an opaque 32-bit type }
  ConstCStringPtr = PChar;

  SInt32  = Integer;
  Float32 = single;
  CGFloat = Float32;
  size_t = Integer;


	CGPointPtr = ^CGPoint;
	CGPoint = record
		x: Float32;
		y: Float32;
	end;

	CGSizePtr = ^CGSize;
	CGSize = record
		width: Float32;
		height: Float32;
	end;

	CGRectPtr = ^CGRect;
	CGRect = record
		origin: CGPoint;
		size: CGSize;
	end;

	CGContextRef = ^SInt32; { an opaque 32-bit type }

type
  CGTextEncoding = Integer;

const
  kCGEncodingFontSpecific = 0;
  kCGEncodingMacRoman = 1;

function GetCGRect(x, y, width, height: single): CGRect;

{ Set the current fill colorspace in the context `c' to `DeviceRGB' and
 * set the components of the current fill color to `(red, green, blue,
 * alpha)'. }

procedure CGContextSetRGBFillColor( c: CGContextRef; red: Float32; green: Float32; blue: Float32; alpha: Float32 ); cdecl; external;

{ Set the current stroke colorspace in the context `c' to `DeviceRGB' and
 * set the components of the current stroke color to `(red, green, blue,
 * alpha)'. }

procedure CGContextSetRGBStrokeColor( c: CGContextRef; red: Float32; green: Float32; blue: Float32; alpha: Float32 ); cdecl; external;

{ Fill `rect' with the current fill color. }

procedure CGContextFillRect( c: CGContextRef; rect: CGRect ); cdecl; external;

{* Text convenience functions. *}

{ Attempts to find the font named `name' and, if successful, sets it as
 * the font in the current graphics state of `c' and sets the font size in
 * the current graphics state to `size'. `textEncoding' specifies how to
 * translate from bytes to glyphs when displaying text. }

procedure CGContextSelectFont( c: CGContextRef; name: ConstCStringPtr; size: Float32; textEncoding: CGTextEncoding ); cdecl; external;

{ Draw `string', a string of `length' bytes, at the point `(x, y)',
 * specified in user space, in the context `c'.  Each byte of the string is
 * mapped through the encoding vector of the current font to obtain the
 * glyph to display. }

procedure CGContextShowTextAtPoint( c: CGContextRef; x: Float32; y: Float32; strng: ConstCStringPtr; length: size_t ); cdecl; external;

{* Coordinate space transformations. *}

{ Scale the current graphics state's transformation matrix (the CTM) by
 * `(sx, sy)'. }

procedure CGContextScaleCTM( c: CGContextRef; sx: Float32; sy: Float32 ); cdecl; external;

{ Translate the current graphics state's transformation matrix (the CTM)
 * by `(tx, ty)'. }

procedure CGContextTranslateCTM( c: CGContextRef; tx: Float32; ty: Float32 ); cdecl; external;

{ Rotate the current graphics state's transformation matrix (the CTM) by
 * `angle' radians. }

procedure CGContextRotateCTM( c: CGContextRef; angle: Float32 ); cdecl; external;


implementation

function GetCGRect(x, y, width, height: single): CGRect;
begin
  Result.origin.x := x;
  Result.origin.y := y;
  Result.size.width := width;
  Result.size.height := height;
end;

end.

