unit objcrtlutils;

{$mode objfpc}{$H+}

interface

uses
  objcrtl;

function alloc(classname: PChar): id; inline;
function objcclass(classname: PChar): _class; inline;
function selector(cmdname: PChar): SEL; inline;
procedure release(objc: id); inline;
function AllocAndInit(classname: PChar): id; inline;

implementation

function alloc(classname: PChar): id; inline;
begin
  Result := objc_msgSend( objc_getClass(classname), selector('alloc'), []);
end;

function objcclass(classname: PChar): _class; inline;
begin
  Result := _class(objc_getClass(classname));
end;

function selector(cmdname: PChar): SEL; inline;
begin
  Result := sel_registerName(cmdname);
end;

procedure release(objc: id);
begin
  objc_msgSend(objc, selector('release'), []);
end;

function AllocAndInit(classname: PChar): id;
begin
  Result:= objc_msgSend( alloc( classname ), selector('init'), []);
end;


end.

